diff -ruNp ejudge-2.3.18/parsecfg.c ejudge/parsecfg.c
--- ejudge-2.3.18/parsecfg.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/parsecfg.c	2011-07-11 09:02:04.527273694 +0400
@@ -1,5 +1,5 @@
 /* -*- c -*- */
-/* $Id: parsecfg.c 6146 2011-03-26 10:47:14Z cher $ */
+/* $Id: parsecfg.c 6246 2011-04-15 04:37:15Z cher $ */
 
 /* Copyright (C) 2000-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -18,6 +18,7 @@
 #include "parsecfg.h"
 #include "charsets.h"
 #include "xml_utils.h"
+#include "misctext.h"
 
 #include "reuse_xalloc.h"
 #include "reuse_logger.h"
@@ -1001,17 +1002,6 @@ read_comment(FILE *f)
 }
 
 static int
-num_suffix(const unsigned char *str)
-{
-  if (!str[0]) return 1;
-  if (str[1]) return 0; 
-  if (str[0] == 'k' || str[0] == 'K') return 1024;
-  if (str[0] == 'm' || str[0] == 'M') return 1024 * 1024;
-  if (str[0] == 'g' || str[0] == 'G') return 1024 * 1024 * 1024;
-  return 0;
-}
-
-static int
 copy_param(void *cfg, const struct config_parse_info *params,
            char *varname, char *varvalue)
 {
@@ -1044,40 +1034,22 @@ copy_param(void *cfg, const struct confi
     ptr = (time_t*) ((char*) cfg + params[i].offset);
     *ptr = v;
   } else if (!strcmp(params[i].type, "z")) {
-    int n, m;
-    size_t v, *ptr;
+    size_t v = 0, *ptr = 0;
 
-#ifdef __WIN32__
-    if (sscanf(varvalue, "%d%n", &v, &n) != 1
-        || !(m = num_suffix(varvalue + n))) {
-      fprintf(stderr, "%d: size parameter expected for '%s'\n",
+    if (size_str_to_size_t(varvalue, &v) < 0) {
+      fprintf(stderr, "%d: invalid value of size parameter for '%s'\n",
               parsecfg_state.lineno - 1, varname);
-      return -1;
+      return -1;              
     }
-#else
-    if (sscanf(varvalue, "%zu%n", &v, &n) != 1
-        || !(m = num_suffix(varvalue + n))) {
-      fprintf(stderr, "%d: size parameter expected for '%s'\n",
-              parsecfg_state.lineno - 1, varname);
-      return -1;
-    }
-#endif /* __WIN32__ */
-    // FIXME: check for overflow 
-    v *= m;
     ptr = (size_t*) ((char*) cfg + params[i].offset);
     *ptr = v;
   } else if (!strcmp(params[i].type, "d")) {
-    int  n, v, m;
-    int *ptr;
-
-    if (sscanf(varvalue, "%d%n", &v, &n) != 1
-        || !(m = num_suffix(varvalue + n))) {
-      fprintf(stderr, "%d: numeric parameter expected for '%s'\n",
+    int v = 0, *ptr = 0;
+    if (size_str_to_num(varvalue, &v) < 0) {
+      fprintf(stderr, "%d: invalid value of numeric parameter for '%s'\n",
               parsecfg_state.lineno - 1, varname);
       return -1;
     }
-    // FIXME: check for overflow 
-    v *= m;
     ptr = (int *) ((char*) cfg + params[i].offset);
     *ptr = v;
   } else if (!strcmp(params[i].type, "s")) {
diff -ruNp ejudge-2.3.18/plugins/mysql-userlist/ChangeLog ejudge/plugins/mysql-userlist/ChangeLog
--- ejudge-2.3.18/plugins/mysql-userlist/ChangeLog	2011-04-10 09:25:23.000000000 +0400
+++ ejudge/plugins/mysql-userlist/ChangeLog	2011-07-11 09:02:03.398294446 +0400
@@ -1,3 +1,58 @@
+2011-06-19 (r6376) Alexander Chernov  <cher@ejudge.ru>
+
+	* uldb_mysql.c:
+	(get_brief_list_iterator_2_func) performance is improved, group_id is supported.
+
+2011-05-14 (r6332) Alexander Chernov  <cher@ejudge.ru>
+
+	* uldb_mysql.c:
+	(set_reg_flags_func) copy operation (4) is supported.
+
+2011-05-08 (r6313) Alexander Chernov  <cher@ejudge.ru>
+
+	* methods.inc.c:
+	(get_prev_user_id_func) new function prototype;
+	(get_next_user_id_func) new function prototype.
+
+	* uldb_mysql.c:
+	(get_prev_user_id_func) new function;
+	(get_next_user_id_func) new function.
+
+2011-05-01 (r6288) Alexander Chernov  <cher@ejudge.ru>
+
+	* methods.inc.c, uldb_mysql.c:
+	(new_user_func) many new parameters are added;
+	(register_contest_func) new parameter 'flags' is added.
+
+2011-04-22 (r6261) Alexander Chernov  <cher@ejudge.ru>
+
+	* methods.inc.c:
+	(get_brief_list_iterator_2_func) 'group_id' parameter is added;
+	(get_group_iterator_2_func) new function prototype;
+	(get_group_count_func) new function prototope.
+
+	* uldb_mysql.c:
+	(get_member_serial_func) a bug is fixed;
+	(get_brief_list_iterator_2_func) 'group_id' parameter is added;
+	(get_group_iterator_2_func) new function;
+	(get_group_count_func) new function.
+
+2011-04-20 (r6253) Alexander Chernov  <cher@ejudge.ru>
+
+	* methods.inc.c:
+	(get_user_count_func) new function prototype.
+
+	* uldb_mysql.c:
+	(get_user_count_func) new function.
+
+2011-04-19 (r6250) Alexander Chernov  <cher@ejudge.ru>
+
+	* methods.inc.c: copyright notice is updated;
+	(get_brief_list_iterator_2_func) function prototype is added.
+
+	* uldb_mysql.c:
+	(get_brief_list_iterator_2_func) new function is added.
+
 2011-03-27 (r6188) Alexander Chernov  <cher@ejudge.ru>
 
 	* main.make, Makefile.in:
diff -ruNp ejudge-2.3.18/plugins/mysql-userlist/create-userdb.sql ejudge/plugins/mysql-userlist/create-userdb.sql
--- ejudge-2.3.18/plugins/mysql-userlist/create-userdb.sql	2011-04-10 09:25:23.000000000 +0400
+++ ejudge/plugins/mysql-userlist/create-userdb.sql	2011-07-11 09:02:03.390294592 +0400
@@ -24,7 +24,7 @@ CREATE TABLE %slogins
 
 CREATE TABLE %scookies
        (cookie VARCHAR(32) NOT NULL PRIMARY KEY,
-       user_id INT NOT NULL,
+       user_id INT UNSIGNED NOT NULL,
        contest_id INT UNSIGNED NOT NULL,
        priv_level TINYINT NOT NULL DEFAULT 0,
        role_id TINYINT NOT NULL DEFAULT 0,
@@ -144,10 +144,10 @@ CREATE TABLE %smembers
 
 CREATE TABLE %sgroups
 (
-    group_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
+    group_id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
     group_name VARCHAR(128) NOT NULL UNIQUE KEY,
     description VARCHAR(512) DEFAULT NULL,
-    created_by INT NOT NULL,
+    created_by INT UNSIGNED NOT NULL,
     create_time DATETIME NOT NULL,
     last_change_time DATETIME DEFAULT NULL,
     FOREIGN KEY (created_by) REFERENCES logins(user_id)
@@ -155,8 +155,8 @@ CREATE TABLE %sgroups
 
 CREATE TABLE %sgroupmembers
 (
-    group_id INT NOT NULL,
-    user_id INT NOT NULL,
+    group_id INT UNSIGNED NOT NULL,
+    user_id INT UNSIGNED NOT NULL,
     rights VARCHAR(512) DEFAULT NULL,
     PRIMARY KEY (group_id, user_id),
     FOREIGN KEY g(group_id) REFERENCES groups(group_id),
diff -ruNp ejudge-2.3.18/plugins/mysql-userlist/methods.inc.c ejudge/plugins/mysql-userlist/methods.inc.c
--- ejudge-2.3.18/plugins/mysql-userlist/methods.inc.c	2011-04-10 09:25:23.000000000 +0400
+++ ejudge/plugins/mysql-userlist/methods.inc.c	2011-07-11 09:02:03.417294096 +0400
@@ -1,7 +1,7 @@
 /* -*- mode: c -*- */
-/* $Id: methods.inc.c 5811 2010-05-28 15:14:24Z cher $ */
+/* $Id: methods.inc.c 6313 2011-05-08 06:57:00Z cher $ */
 
-/* Copyright (C) 2008-2010 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2008-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -56,8 +56,17 @@ new_user_func(
         void *data,
         const unsigned char *login,
         const unsigned char *email,
+        int passwd_method,
         const unsigned char *passwd,
-        int simple_reg_flag);
+        int is_privileged,
+        int is_invisible,
+        int is_banned,
+        int is_locked,
+        int show_login,
+        int show_email,
+        int read_only,
+        int never_clean,
+        int simple_registration);
 static int
 remove_user_func(
         void *data,
@@ -189,6 +198,7 @@ register_contest_func(
         int user_id,
         int contest_id,
         int status,
+        int flags,
         time_t cur_time,
         const struct userlist_contest **p_c);
 static int
@@ -435,6 +445,48 @@ static int
 create_group_member_func(void *data, int group_id, int user_id);
 static int
 remove_group_member_func(void *data, int group_id, int user_id);
+static ptr_iterator_t
+get_brief_list_iterator_2_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        int offset,
+        int count);
+static int
+get_user_count_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        long long *p_count);
+static ptr_iterator_t
+get_group_iterator_2_func(
+        void *data,
+        const unsigned char *filter,
+        int offset,
+        int count);
+static int
+get_group_count_func(
+        void *data,
+        const unsigned char *filter,
+        long long *p_count);
+static int
+get_prev_user_id_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id);
+static int
+get_next_user_id_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id);
 
 /*
  * Local variables:
diff -ruNp ejudge-2.3.18/plugins/mysql-userlist/uldb_mysql.c ejudge/plugins/mysql-userlist/uldb_mysql.c
--- ejudge-2.3.18/plugins/mysql-userlist/uldb_mysql.c	2011-04-10 09:25:23.000000000 +0400
+++ ejudge/plugins/mysql-userlist/uldb_mysql.c	2011-07-11 09:02:03.414294150 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: uldb_mysql.c 6153 2011-03-27 06:52:33Z cher $ */
+/* $Id: uldb_mysql.c 6376 2011-06-19 19:43:53Z cher $ */
 
 /* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -228,6 +228,18 @@ struct uldb_plugin_iface plugin_uldb_mys
   create_group_member_func,
   // remove a group member
   remove_group_member_func,
+  // get a user iterator
+  get_brief_list_iterator_2_func,
+  // get the total count of the users
+  get_user_count_func,
+  // get a group iterator
+  get_group_iterator_2_func,
+  // get the total count of the groups
+  get_group_count_func,
+  // get the previous user
+  get_prev_user_id_func,
+  // get the next user
+  get_next_user_id_func,
 };
 
 // the size of the cookies pool, must be power of 2
@@ -1032,8 +1044,17 @@ new_user_func(
         void *data,
         const unsigned char *login,
         const unsigned char *email,
+        int passwd_method,
         const unsigned char *passwd,
-        int simple_reg_flag)
+        int is_privileged,
+        int is_invisible,
+        int is_banned,
+        int is_locked,
+        int show_login,
+        int show_email,
+        int read_only,
+        int never_clean,
+        int simple_registration)
 {
   struct uldb_mysql_state *state = (struct uldb_mysql_state*) data;
   int val, inserted_flag = 0;
@@ -1051,7 +1072,16 @@ new_user_func(
     user.login = (char*) login;
     user.email = (char*) email;
     user.passwd = (char*) passwd;
-    user.simple_registration = !!simple_reg_flag;
+    user.passwd_method = passwd_method;
+    user.is_privileged = !!is_privileged;
+    user.is_invisible = !!is_invisible;
+    user.is_banned = !!is_banned;
+    user.is_locked = !!is_locked;
+    user.show_login = !!show_login;
+    user.show_email = !!show_email;
+    user.read_only = !!read_only;
+    user.never_clean = !!never_clean;
+    user.simple_registration = !!simple_registration;
 
     cmd_f = open_memstream(&cmd_t, &cmd_z);
     fprintf(cmd_f, "INSERT into %slogins VALUES ( ", state->md->table_prefix);
@@ -1070,7 +1100,16 @@ new_user_func(
     user.login = (char*) login;
     user.email = (char*) email;
     user.passwd = (char*) passwd;
-    user.simple_registration = !!simple_reg_flag;
+    user.passwd_method = passwd_method;
+    user.is_privileged = !!is_privileged;
+    user.is_invisible = !!is_invisible;
+    user.is_banned = !!is_banned;
+    user.is_locked = !!is_locked;
+    user.show_login = !!show_login;
+    user.show_email = !!show_email;
+    user.read_only = !!read_only;
+    user.never_clean = !!never_clean;
+    user.simple_registration = !!simple_registration;
 
     cmd_f = open_memstream(&cmd_t, &cmd_z);
     fprintf(cmd_f, "INSERT into %slogins VALUES ( ", state->md->table_prefix);
@@ -2425,6 +2464,7 @@ register_contest_func(
         int user_id,
         int contest_id,
         int status,
+        int flags,
         time_t cur_time,
         const struct userlist_contest **p_c)
 {
@@ -2445,6 +2485,7 @@ register_contest_func(
   memset(&new_uc, 0, sizeof(new_uc));
   new_uc.id = contest_id;
   new_uc.status = status;
+  new_uc.flags = flags;
   new_uc.create_time = cur_time;
   new_uc.last_change_time = cur_time;
   cmd_f = open_memstream(&cmd_t, &cmd_z);
@@ -2899,6 +2940,18 @@ set_reg_flags_func(
       sep = ", ";
     }
     break;
+  case 4:                       /* copy */
+    fprintf(cmd_f, "%sinvisible = %d", sep, !!(value & USERLIST_UC_INVISIBLE));
+    sep = ", ";
+    fprintf(cmd_f, "%sbanned = %d", sep, !!(value & USERLIST_UC_BANNED));
+    sep = ", ";
+    fprintf(cmd_f, "%slocked = %d", sep, !!(value & USERLIST_UC_LOCKED));
+    sep = ", ";
+    fprintf(cmd_f, "%sincomplete = %d", sep, !!(value & USERLIST_UC_INCOMPLETE));
+    sep = ", ";
+    fprintf(cmd_f, "%sdisqualified = %d", sep, !!(value & USERLIST_UC_DISQUALIFIED));
+    sep = ", ";
+    break;
   default:
     abort();
   }
@@ -3891,7 +3944,10 @@ get_member_serial_func(void *data)
   snprintf(cmdbuf, sizeof(cmdbuf), "SELECT MAX(serial) FROM %smembers WHERE 1 ;", state->md->table_prefix);
   cmdlen = strlen(cmdbuf);
   if (state->mi->query_one_row(state->md, cmdbuf, cmdlen, 1) < 0) goto fail;
-  if (state->mi->int_val(state->md, &current_member, 1) < 0) goto fail;
+  if (!state->md->lengths[0])
+    db_error_inv_value_fail(state->md, "value");
+  if (state->mi->parse_int(state->md, state->md->row[0], &current_member) < 0 || current_member <= 0)
+    db_error_inv_value_fail(state->md, "value");
   state->mi->free_res(state->md);
   return current_member;
 
@@ -4810,6 +4866,453 @@ remove_group_member_func(void *data, int
   return 0;
 }
 
+static ptr_iterator_t
+get_brief_list_iterator_2_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        int offset,
+        int count)
+{
+  struct uldb_mysql_state *state = (struct uldb_mysql_state*) data;
+  struct brief_list_iterator *iter = 0;
+  int i, val, j;
+  FILE *uid_f = NULL;
+  char *uid_t = NULL;
+  size_t uid_z = 0;
+
+  if (offset < 0) offset = 0;
+  if (count < 0) count = 0;
+  if (offset + count < 0) count = 0;
+
+  XCALLOC(iter, 1);
+  iter->b = brief_list_iterator_funcs;
+  iter->state = state;
+  iter->contest_id = contest_id;
+  iter->cur_ind = 0;
+
+  if (contest_id <= 0 && group_id > 0) {
+    if (state->mi->fquery(state->md, LOGIN_WIDTH,
+                  "SELECT l.* FROM %slogins AS l, %sgroupmembers AS m WHERE l.user_id = m.user_id AND m.group_id = %d ORDER BY l.user_id LIMIT %d, %d;",
+                          state->md->table_prefix,
+                          state->md->table_prefix,
+                          group_id, offset, count) < 0)
+      goto fail;
+    iter->total_ids = state->md->row_count;
+    if (!iter->total_ids) {
+      state->mi->free_res(state->md);
+      return (ptr_iterator_t) iter;
+    }
+
+    uid_f = open_memstream(&uid_t, &uid_z);
+    XCALLOC(iter->noreg_rows, iter->total_ids);
+    for (i = 0; i < iter->total_ids; i++) {
+      if (!(state->md->row = mysql_fetch_row(state->md->res)))
+        db_error_no_data_fail(state->md);
+      state->md->lengths = mysql_fetch_lengths(state->md->res);
+      if (!state->md->lengths[0])
+        db_error_inv_value_fail(state->md, "value");
+      if (state->mi->parse_int(state->md, state->md->row[0], &val) < 0 || val <= 0)
+        db_error_inv_value_fail(state->md, "value");
+      iter->noreg_rows[i].user_id = val;
+      copy_saved_row(state, &iter->noreg_rows[i].login_row);
+      if (i > 0) fprintf(uid_f, ", ");
+      fprintf(uid_f, "%d", val);
+    }
+    fclose(uid_f); uid_f = NULL;
+
+    if (!uid_t && !*uid_t) {
+      xfree(uid_t); uid_t = 0;
+      state->mi->free_res(state->md);
+      return (ptr_iterator_t) iter;
+    }
+
+    state->mi->free_res(state->md);
+    if (state->mi->fquery(state->md, USER_INFO_WIDTH,
+                  "SELECT * FROM %susers WHERE contest_id = 0 AND user_id IN (%s) ORDER BY user_id;",
+                          state->md->table_prefix, uid_t) < 0)
+      goto fail;
+    xfree(uid_t); uid_t = 0; uid_z = 0;
+    j = 0;
+    for (i = 0; i < state->md->row_count; i++) {
+      if (!(state->md->row = mysql_fetch_row(state->md->res)))
+        db_error_no_data_fail(state->md);
+      state->md->lengths = mysql_fetch_lengths(state->md->res);
+      if (!state->md->lengths[0])
+        db_error_inv_value_fail(state->md, "value");
+      if (state->mi->parse_int(state->md, state->md->row[0], &val) < 0 || val <= 0)
+        db_error_inv_value_fail(state->md, "value");
+      while (j < iter->total_ids && iter->noreg_rows[j].user_id < val) j++;
+      if (j < iter->total_ids && iter->noreg_rows[j].user_id == val) {
+        copy_saved_row(state, &iter->noreg_rows[j].user_info_row);
+      }
+    }
+
+    state->mi->free_res(state->md);
+    return (ptr_iterator_t) iter;
+  }
+
+  if (!contest_id) {
+    if (state->mi->fquery(state->md, LOGIN_WIDTH,
+                  "SELECT * FROM %slogins WHERE 1 ORDER BY user_id LIMIT %d, %d;",
+                          state->md->table_prefix, offset, count) < 0)
+      goto fail;
+    iter->total_ids = state->md->row_count;
+    if (!iter->total_ids) {
+      state->mi->free_res(state->md);
+      return (ptr_iterator_t) iter;
+    }
+
+    uid_f = open_memstream(&uid_t, &uid_z);
+    XCALLOC(iter->noreg_rows, iter->total_ids);
+    for (i = 0; i < iter->total_ids; i++) {
+      if (!(state->md->row = mysql_fetch_row(state->md->res)))
+        db_error_no_data_fail(state->md);
+      state->md->lengths = mysql_fetch_lengths(state->md->res);
+      if (!state->md->lengths[0])
+        db_error_inv_value_fail(state->md, "value");
+      if (state->mi->parse_int(state->md, state->md->row[0], &val) < 0 || val <= 0)
+        db_error_inv_value_fail(state->md, "value");
+      iter->noreg_rows[i].user_id = val;
+      copy_saved_row(state, &iter->noreg_rows[i].login_row);
+      if (i > 0) fprintf(uid_f, ", ");
+      fprintf(uid_f, "%d", val);
+    }
+    fclose(uid_f); uid_f = NULL;
+
+    if (!uid_t && !*uid_t) {
+      state->mi->free_res(state->md);
+      return (ptr_iterator_t) iter;
+    }
+
+    state->mi->free_res(state->md);
+    if (state->mi->fquery(state->md, USER_INFO_WIDTH,
+                  "SELECT * FROM %susers WHERE contest_id = 0 AND user_id IN (%s) ORDER BY user_id ;",
+                          state->md->table_prefix, uid_t) < 0)
+      goto fail;
+    xfree(uid_t); uid_t = 0; uid_z = 0;
+    j = 0;
+    for (i = 0; i < state->md->row_count; i++) {
+      if (!(state->md->row = mysql_fetch_row(state->md->res)))
+        db_error_no_data_fail(state->md);
+      state->md->lengths = mysql_fetch_lengths(state->md->res);
+      if (!state->md->lengths[0])
+        db_error_inv_value_fail(state->md, "value");
+      if (state->mi->parse_int(state->md, state->md->row[0], &val) < 0 || val <= 0)
+        db_error_inv_value_fail(state->md, "value");
+      while (j < iter->total_ids && iter->noreg_rows[j].user_id < val) j++;
+      if (j < iter->total_ids && iter->noreg_rows[j].user_id == val) {
+        copy_saved_row(state, &iter->noreg_rows[j].user_info_row);
+      }
+    }
+
+    state->mi->free_res(state->md);
+    return (ptr_iterator_t) iter;
+  }
+
+  if (state->mi->fquery(state->md, LOGIN_WIDTH,
+                        "SELECT %slogins.* FROM %slogins, %scntsregs WHERE %slogins.user_id = %scntsregs.user_id AND %scntsregs.contest_id = %d ORDER BY %slogins.user_id LIMIT %d, %d;",
+                        state->md->table_prefix, state->md->table_prefix, state->md->table_prefix,
+                        state->md->table_prefix, state->md->table_prefix, state->md->table_prefix,
+                        contest_id, state->md->table_prefix, offset, count) < 0)
+    goto fail;
+
+  iter->total_ids = state->md->row_count;
+  if (!iter->total_ids) {
+    state->mi->free_res(state->md);
+    return (ptr_iterator_t) iter;
+  }
+
+  uid_f = open_memstream(&uid_t, &uid_z);
+  XCALLOC(iter->full_rows, iter->total_ids);
+  for (i = 0; i < iter->total_ids; i++) {
+    if (!(state->md->row = mysql_fetch_row(state->md->res)))
+      db_error_no_data_fail(state->md);
+    state->md->lengths = mysql_fetch_lengths(state->md->res);
+    if (!state->md->lengths[0])
+      db_error_inv_value_fail(state->md, "value");
+    if (state->mi->parse_int(state->md, state->md->row[0], &val) < 0 || val <= 0)
+      db_error_inv_value_fail(state->md, "value");
+    iter->full_rows[i].user_id = val;
+    copy_saved_row(state, &iter->full_rows[i].login_row);
+    if (i > 0) fprintf(uid_f, ", ");
+    fprintf(uid_f, "%d", val);
+  }
+  fclose(uid_f); uid_f = NULL;
+  state->mi->free_res(state->md);
+
+  if (!uid_t && !*uid_t) {
+    state->mi->free_res(state->md);
+    return (ptr_iterator_t) iter;
+  }
+
+  if (state->mi->fquery(state->md, USER_INFO_WIDTH,
+                "SELECT * FROM %susers WHERE contest_id = %d AND user_id IN (%s) ORDER BY user_id ;",
+                        state->md->table_prefix, contest_id, uid_t) < 0)
+    goto fail;
+  j = 0;
+  for (i = 0; i < state->md->row_count; i++) {
+    if (!(state->md->row = mysql_fetch_row(state->md->res)))
+      db_error_no_data_fail(state->md);
+    state->md->lengths = mysql_fetch_lengths(state->md->res);
+    if (!state->md->lengths[0])
+      db_error_inv_value_fail(state->md, "value");
+    if (state->mi->parse_int(state->md, state->md->row[0], &val) < 0 || val <= 0)
+      db_error_inv_value_fail(state->md, "value");
+    while (j < iter->total_ids && iter->full_rows[j].user_id < val) j++;
+    if (j < iter->total_ids && iter->full_rows[j].user_id == val) {
+      copy_saved_row(state, &iter->full_rows[j].user_info_row);
+    }
+  }
+  state->mi->free_res(state->md);
+
+  if (state->mi->fquery(state->md, CNTSREG_WIDTH,
+                        "SELECT * FROM %scntsregs WHERE contest_id = %d AND user_id IN (%s) ORDER BY user_id ;",
+                        state->md->table_prefix, contest_id, uid_t) < 0)
+    goto fail;
+  xfree(uid_t); uid_t = 0; uid_z = 0;
+  j = 0;
+  for (i = 0; i < state->md->row_count; i++) {
+    if (!(state->md->row = mysql_fetch_row(state->md->res)))
+      db_error_no_data_fail(state->md);
+    state->md->lengths = mysql_fetch_lengths(state->md->res);
+    if (!state->md->lengths[0])
+      db_error_inv_value_fail(state->md, "value");
+    if (state->mi->parse_int(state->md, state->md->row[0], &val) < 0 || val <= 0)
+      db_error_inv_value_fail(state->md, "value");
+    while (j < iter->total_ids && iter->full_rows[j].user_id < val) j++;
+    if (j < iter->total_ids && iter->full_rows[j].user_id == val) {
+      copy_saved_row(state, &iter->full_rows[j].cntsreg_row);
+    }
+  }
+  state->mi->free_res(state->md);
+
+  return (ptr_iterator_t) iter;
+
+ fail:
+  if (uid_f) {
+    fclose(uid_f);
+    uid_f = 0;
+  }
+  xfree(uid_t); uid_t = 0;
+  state->mi->free_res(state->md);
+  brief_list_iterator_destroy_func((ptr_iterator_t) iter);
+  return 0;
+}
+
+static int
+get_user_count_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        long long *p_count)
+{
+  struct uldb_mysql_state *state = (struct uldb_mysql_state*) data;
+  unsigned char cmdbuf[1024];
+  int cmdlen, count = 0;
+
+  if (contest_id > 0 && group_id > 0) {
+    // FIXME:
+    abort();
+  } else if (contest_id > 0) {
+    snprintf(cmdbuf, sizeof(cmdbuf), "SELECT COUNT(%slogins.user_id) FROM %slogins, %scntsregs WHERE %slogins.user_id = %scntsregs.user_id AND %scntsregs.contest_id = %d;",
+             state->md->table_prefix, state->md->table_prefix,
+             state->md->table_prefix, state->md->table_prefix,
+             state->md->table_prefix, state->md->table_prefix, contest_id);
+  } else if (group_id > 0) {
+  } else {
+    snprintf(cmdbuf, sizeof(cmdbuf), "SELECT COUNT(user_id) FROM %slogins WHERE 1 ;", state->md->table_prefix);
+  }
+
+  cmdlen = strlen(cmdbuf);
+  if (state->mi->query_one_row(state->md, cmdbuf, cmdlen, 1) < 0) goto fail;
+  if (!state->md->lengths[0])
+    db_error_inv_value_fail(state->md, "value");
+  if (state->mi->parse_int(state->md, state->md->row[0], &count) < 0 || count <= 0)
+    db_error_inv_value_fail(state->md, "value");
+  state->mi->free_res(state->md);
+  if (p_count) *p_count = count;
+  return 0;
+
+fail:
+  state->mi->free_res(state->md);
+  return 0;
+}
+
+static ptr_iterator_t
+get_group_iterator_2_func(
+        void *data,
+        const unsigned char *filter,
+        int offset,
+        int count)
+{
+  struct uldb_mysql_state *state = (struct uldb_mysql_state*) data;
+  char *cmd_t = 0;
+  size_t cmd_z = 0;
+  FILE *cmd_f = 0;
+  struct group_iterator *iter = 0;
+  int i;
+
+  if (offset < 0) offset = 0;
+  if (count < 0) count = 0;
+
+  XCALLOC(iter, 1);
+  iter->b = group_iterator_funcs;
+
+  cmd_f = open_memstream(&cmd_t, &cmd_z);
+  fprintf(cmd_f, "SELECT * FROM %sgroups WHERE 1 ORDER BY group_id LIMIT %d, %d;",
+          state->md->table_prefix, offset, count);
+  fclose(cmd_f); cmd_f = 0;
+  if (state->mi->query(state->md, cmd_t, cmd_z, USERGROUP_WIDTH) < 0)
+    goto fail;
+  xfree(cmd_t); cmd_t = 0; cmd_z = 0;
+  iter->group_count = state->md->row_count;
+  if (iter->group_count <= 0) {
+    state->mi->free_res(state->md);
+    return (ptr_iterator_t) iter;
+  }
+  XCALLOC(iter->groups, iter->group_count);
+  for (i = 0; i < iter->group_count; ++i) {
+    if (!(state->md->row = mysql_fetch_row(state->md->res)))
+      db_error_no_data_fail(state->md);
+    state->md->lengths = mysql_fetch_lengths(state->md->res);
+    iter->groups[i] = (struct userlist_group*) userlist_node_alloc(USERLIST_T_USERGROUP);
+    if (parse_group(state, state->md->field_count, state->md->row,
+                    state->md->lengths, iter->groups[i]) < 0) goto fail;
+  }
+
+  state->mi->free_res(state->md);
+  return (ptr_iterator_t) iter;
+
+fail:
+  state->mi->free_res(state->md);
+  group_iterator_destroy_func((ptr_iterator_t) iter);
+  if (cmd_f) fclose(cmd_f);
+  xfree(cmd_t);
+  return 0;
+}
+
+static int
+get_group_count_func(
+        void *data,
+        const unsigned char *filter,
+        long long *p_count)
+{
+  struct uldb_mysql_state *state = (struct uldb_mysql_state*) data;
+  unsigned char cmdbuf[1024];
+  int cmdlen, count = 0;
+
+  snprintf(cmdbuf, sizeof(cmdbuf), "SELECT COUNT(group_id) FROM %sgroups WHERE 1 ;", state->md->table_prefix);
+
+  cmdlen = strlen(cmdbuf);
+  if (state->mi->query_one_row(state->md, cmdbuf, cmdlen, 1) < 0) goto fail;
+  if (!state->md->lengths[0])
+    db_error_inv_value_fail(state->md, "value");
+  if (state->mi->parse_int(state->md, state->md->row[0], &count) < 0 || count <= 0)
+    db_error_inv_value_fail(state->md, "value");
+  state->mi->free_res(state->md);
+  if (p_count) *p_count = count;
+  return 0;
+
+fail:
+  state->mi->free_res(state->md);
+  return 0;
+}
+
+static int
+get_prev_user_id_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id)
+{
+  struct uldb_mysql_state *state = (struct uldb_mysql_state*) data;
+  unsigned char cmdbuf[1024];
+  int cmdlen;
+
+  if (contest_id > 0 && group_id > 0) group_id = 0; // FIXME
+  if (group_id > 0) group_id = 0;                   /* FIXME */
+  if (p_user_id) *p_user_id = 0;
+
+  if (contest_id > 0 && group_id > 0) {
+    abort();
+  } else if (contest_id > 0) {
+    snprintf(cmdbuf, sizeof(cmdbuf), "SELECT %slogins.user_id FROM %slogins, %scntsregs WHERE %slogins.user_id = %scntsregs.user_id AND %scntsregs.contest_id = %d AND %slogins.user_id < %d ORDER BY %slogins.user_id DESC LIMIT 0, 1;",
+             state->md->table_prefix, state->md->table_prefix,
+             state->md->table_prefix, state->md->table_prefix,
+             state->md->table_prefix, state->md->table_prefix, contest_id,
+             state->md->table_prefix, user_id,
+             state->md->table_prefix);
+  } else if (group_id > 0) {
+    abort();
+  } else {
+    snprintf(cmdbuf, sizeof(cmdbuf), "SELECT user_id FROM %slogins WHERE user_id < %d ORDER BY user_id DESC LIMIT 0, 1;",
+             state->md->table_prefix, user_id);
+  }
+  cmdlen = strlen(cmdbuf);
+  if (state->mi->query(state->md, cmdbuf, cmdlen, 1) < 0) goto fail;
+  if (state->md->row_count != 1) goto fail;
+  if (!(state->md->row = mysql_fetch_row(state->md->res))) goto fail;
+  state->md->lengths = mysql_fetch_lengths(state->md->res);
+  if (!state->md->lengths[0]) goto fail;
+  if (state->mi->parse_int(state->md, state->md->row[0], &user_id) < 0 || user_id <= 0) goto fail;
+  if (p_user_id) *p_user_id = user_id;
+
+fail:
+  state->mi->free_res(state->md);
+  return 0;
+}
+
+static int
+get_next_user_id_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id)
+{
+  struct uldb_mysql_state *state = (struct uldb_mysql_state*) data;
+  unsigned char cmdbuf[1024];
+  int cmdlen;
+
+  if (contest_id > 0 && group_id > 0) group_id = 0; // FIXME
+  if (group_id > 0) group_id = 0;                   /* FIXME */
+  if (p_user_id) *p_user_id = 0;
+
+  if (contest_id > 0 && group_id > 0) {
+    abort();
+  } else if (contest_id > 0) {
+    snprintf(cmdbuf, sizeof(cmdbuf), "SELECT %slogins.user_id FROM %slogins, %scntsregs WHERE %slogins.user_id = %scntsregs.user_id AND %scntsregs.contest_id = %d AND %slogins.user_id > %d ORDER BY %slogins.user_id LIMIT 0, 1;",
+             state->md->table_prefix, state->md->table_prefix,
+             state->md->table_prefix, state->md->table_prefix,
+             state->md->table_prefix, state->md->table_prefix, contest_id,
+             state->md->table_prefix, user_id,
+             state->md->table_prefix);
+  } else if (group_id > 0) {
+    abort();
+  } else {
+    snprintf(cmdbuf, sizeof(cmdbuf), "SELECT user_id FROM %slogins WHERE user_id > %d ORDER BY user_id DESC LIMIT 0, 1;",
+             state->md->table_prefix, user_id);
+  }
+  cmdlen = strlen(cmdbuf);
+  if (state->mi->query(state->md, cmdbuf, cmdlen, 1) < 0) goto fail;
+  if (state->md->row_count != 1) goto fail;
+  if (!(state->md->row = mysql_fetch_row(state->md->res))) goto fail;
+  state->md->lengths = mysql_fetch_lengths(state->md->res);
+  if (!state->md->lengths[0]) goto fail;
+  if (state->mi->parse_int(state->md, state->md->row[0], &user_id) < 0 || user_id <= 0) goto fail;
+  if (p_user_id) *p_user_id = user_id;
+
+fail:
+  state->mi->free_res(state->md);
+  return 0;
+}
+
 /*
  * Local variables:
  *  compile-command: "make"
diff -ruNp ejudge-2.3.18/prepare.c ejudge/prepare.c
--- ejudge-2.3.18/prepare.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/prepare.c	2011-07-11 09:02:04.546273344 +0400
@@ -1,5 +1,5 @@
 /* -*- c -*- */
-/* $Id: prepare.c 6229 2011-04-07 08:49:11Z cher $ */
+/* $Id: prepare.c 6345 2011-05-23 04:20:49Z cher $ */
 
 /* Copyright (C) 2000-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -3058,7 +3058,7 @@ set_defaults(
       }
     }
 
-    if (lang->style_checker_cmd[0] && lang->style_checker_cmd[0] != '@') {
+    if (lang->style_checker_cmd[0] && lang->style_checker_cmd[0] != '@' && lang->style_checker_cmd[0] != '%') {
       pathmake2(lang->style_checker_cmd, g->ejudge_checkers_dir,
                 "/", lang->style_checker_cmd, NULL);
     }
